unit FFT2SharpnessMain;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.ExtDlgs, Vcl.StdCtrls, Vcl.ExtCtrls, system.Math,
  system.UITypes, Vcl.Grids;

type
  D2array = array of array of Double;
  B2array = array of array of Byte;
  TDarray = array[0..0] of Double;
  PDarray = ^TDarray;

  TForm1 = class(TForm)
    FileOpenBtn: TButton;
    OpenPictureDialog1: TOpenPictureDialog;
    MaskingBtn: TButton;
    RadioGroup1: TRadioGroup;
    FileSaveBtn: TButton;
    SavePictureDialog1: TSavePictureDialog;
    SigumaGrid: TStringGrid;
    SigumaEdit: TLabeledEdit;
    sourceBtn: TButton;
    UnsharpEdit: TLabeledEdit;
    RangeEdit: TLabeledEdit;
    Timer1: TTimer;
    ScrollBox1: TScrollBox;
    Image1: TImage;
    RepaintBtn: TButton;
    magnificationEdit: TLabeledEdit;
    SharpnessEdit: TLabeledEdit;
    SharpnessGrid: TStringGrid;
    UnsharpKEdit: TLabeledEdit;
    procedure FileOpenBtnClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure MaskingBtnClick(Sender: TObject);
    procedure FileSaveBtnClick(Sender: TObject);
    procedure sourceBtnClick(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure RepaintBtnClick(Sender: TObject);
    procedure SigumaEditChange(Sender: TObject);
    procedure RangeEditChange(Sender: TObject);
    procedure UnsharpEditChange(Sender: TObject);
    procedure RadioGroup1Click(Sender: TObject);
    procedure SharpnessEditChange(Sender: TObject);
    procedure UnsharpKEditChange(Sender: TObject);
  private
    { Private 錾 }
    procedure FFT2(var a_rl, a_im: D2array; inv, Y_EXP, X_EXP: Integer);
    procedure cstb(length: Integer; inv: integer; var sin_tbl, cos_tbl: array of double);
    procedure fft1core(a_rl, a_im: PDarray; length, ex, inv: integer;
                    sin_tbl, cos_tbl, buf: PDarray);
    procedure birv(a: PDarray; length, ex: Integer; b: PDarray);
    procedure rvmtx1(var a, b: D2array; xsize, ysize: Integer);
    procedure rvmtx2(var a, b: D2array; xsize, ysize: integer);
    function  SigumaMatSet: boolean;
    procedure LaplacianMask;
    procedure Imageout(Image: TBitmap);
    procedure Masking(mask: D2array; size :integer);
    procedure GaussianRoutine;
    procedure SharpnessMask;
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

const
  OpenFileFilter =
    '摜t@C|*.png;*.jpg;*.gif;*.bmp;*.tif;*.ico;*.wdp'+
    '|*.png|*.png' +
    '|*.jpg|*.jpg' +
    '|*.gif|*.gif' +
    '|*.bmp|*.bmp' +
    '|*.tif|*.tif' +
    '|*.ico|*.ico' +
    '|*.wdp|*.wdp';

  SaveFileFilter =
    '摜t@C|*.png;*.jpg;*.gif;*.bmp;*.tif;*.wdp' +
    '|*.png|*.png' +
    '|*.jpg|*.jpg' +
    '|*.gif|*.gif' +
    '|*.bmp|*.bmp' +
    '|*.tif|*.tif' +
    '|*.wdp|*.wdp';

  ImageHWC   = 440;    // \gTCY

  gaus  = 9;
  sharp = 3;

  Laplacian     = 0;
  Gaussians     = 1;
  Deconvolution = 2;
  Unsharp       = 3;
  Sharpness     = 4;

var
  InputDBitmap  : TBitmap;                    // ̓f[^[\prbg}bv
  OutputBitmap  : TBitmap;                    // ]摜\prbg}bv
  GHeight       : Integer;                    // ̓f[^[摜
  GWidth        : Integer;                    // ̓f[^[摜

  VRect         : Trect;                      // \TCYݒp
  InFilename    : string;                     // ̓t@C
  GryMat        : B2array;
  RedMat        : B2array;
  GrnMat        : B2array;
  BluMat        : B2array;
  X_EXP, Y_EXP  : Integer;                    // ݏ
  threshold     : Double;                     // ͈͎w
  Gaussian      : D2array;
  sharparray    : D2array;
  TimerF        : Integer;

const
  kr  = 0.299;                     // R PxϊW
  kg  = 0.587;                     // G PxϊW
  kb  = 0.114;                     // B PxϊW

//------------------------
// ϔ{o
//------------------------
procedure TForm1.Imageout(Image: TBitmap);
var
  Rect0           : Trect;
  magnification   : Double;
  Check           : Integer;
  MW, MH          : Integer;
begin
  Val(magnificationEdit.Text,magnification,Check);
  if Check <> 0 then begin
    application.MessageBox('\{͂ɊԈႢ܂B','',0);
    exit;
  end;
  MW := Round(GWidth * magnification);
  MH := Round(GHeight * magnification);
  Rect0 := Rect(0, 0, MW, MH);
  Image1.Width := MW;
  Image1.Height := MH;
  Image1.Picture.Bitmap.SetSize(MW, MH);
  Image1.Canvas.StretchDraw(Rect0, Image);                // o͘gɕϔ{o
end;

//--- rvmtx2 --- Qf[^̓]u -------------------------------------------
//    a:        Q̓f[^
//    b:        Qo̓f[^
//    xsize:    f[^
//    ysize:    f[^
//-----------------------------------------------------------------------------
procedure TForm1.rvmtx2(var a, b: D2array; xsize, ysize: integer);
var
  i, j: integer;
begin
  for i := 0 to ysize - 1 do
    for j := 0 to xsize - 1 do b[i, j] := a[j, i];
end;

//--- rvmtx1 --- Qf[^̓]u -------------------------------------------
//    a:        Q̓f[^
//    b:        Qo̓f[^
//    xsize:    f[^
//    ysize:    f[^
//-----------------------------------------------------------------------------
procedure TForm1.rvmtx1(var a, b: D2array; xsize, ysize: Integer);
var
  i, j: integer;
begin
  for i := 0 to ysize - 1 do
    for j := 0 to  xsize - 1 do b[j, i] := a[i, j];
end;

//--- birv --- f[^̕׊ -----------------------------------------------
//    a:       f[^̔z
//    length:  f[^
//    ex:      f[^Q̗ݏŗ^܂(2exj
//    b:       Ɨpobt@
//-----------------------------------------------------------------------------
procedure TForm1.birv(a: PDarray; length, ex: Integer; b: PDarray);
var
  i, ii, k, bit : Integer;
begin
  for i := 0 to length - 1 do begin
    ii := i;
    bit:= 0;
    for k := 0 to ex do begin
      bit := (ii and 1) or bit;
      if k = ex - 1 then break;
      bit := bit shl 1;
      ii := ii shr 1;
    end;
    b[i] := a[bit];
  end;
  for i := 0 to length - 1 do a[i] := b[i];
end;

//--- fft1core --- PeešvZ̊jɂȂ镔 ---------------------------
//    a_rl:    f[^io͌pj
//    a_im:    f[^io͌pj
//    ex:        f[^Q̗ݏŗ^܂(2exj
//    sin_tbl:    SINvZpe[u
//    cos_tbl:    COSvZpe[u
//-----------------------------------------------------------------------------
procedure TForm1.fft1core(a_rl, a_im: PDarray; length, ex, inv: integer;
        sin_tbl, cos_tbl, buf: PDarray);
var
  i, j, k, w, j1, j2    : Integer;
  numb, lenb, timb      : Integer;
  xr, xi, yr, yi, nrml  : Double;
begin
  numb := 1;
  lenb := length;
  for i := 0 to ex - 1 do begin
    lenb := lenb div 2;
    timb := 0;
    for j := 0 to numb - 1 do begin
      w := 0;
      for k := 0 to lenb - 1 do  begin
        j1 := timb + k;
        j2 := j1 + lenb;
        xr := a_rl[j1];
        xi := a_im[j1];
        yr := a_rl[j2];
        yi := a_im[j2];
        a_rl[j1] := xr + yr;
        a_im[j1] := xi + yi;
        xr := xr - yr;
        xi := xi - yi;
        a_rl[j2] := xr * cos_tbl[w] - xi * sin_tbl[w];
        a_im[j2] := xr * sin_tbl[w] + xi * cos_tbl[w];
        w := w + numb;
      end;
      timb := timb + 2 * lenb;
    end;
    numb := numb * 2;
  end;
  birv(a_rl, length, ex, buf);          // f[^̕׊
  birv(a_im, length, ex, buf);          // f[^̕׊
  if inv = 2 then nrml := 1             // vVAtB^[ f[^[ŏZȂ
    else
      nrml := 1.0 / sqrt(length);       // { lf[^[ŏZ܂XyNg\̈׃f[^[̕ŏZ
  for i := 0 to length - 1 do begin     // 摜ɍĕϊꍇ́AǉẐŃf[^[ŏZꂽɂȂ܂
    a_rl[i] := a_rl[i] * nrml;
    a_im[i] := a_im[i] * nrml;
  end;
end;

//--- cstb --- SIN,COSe[u쐬 --------------------------------------------
//    length:        f[^
//    inv:        1: Fes, -1: tFes
//    sin_tbl:    SINvZpe[u
//    cos_tbl:    COSvZpe[u
//-----------------------------------------------------------------------------
procedure TForm1.cstb(length: Integer; inv: Integer; var sin_tbl, cos_tbl: array of double);
var
  i : Integer;
  xx, arg : Double;
begin
  xx := - PI * 2.0 / length;
  if inv < 0 then xx := - xx;
  for i := 0 to length - 1 do begin
    arg := i * xx;
    sin_tbl[i] := sin(arg);
    cos_tbl[i] := cos(arg);
  end;
end;

//--- fft2 --- Qees̎s ---------------------------------------------
//   iGWidthCGHeightQׂ̂̏ꍇɌ܂j
//    a_rl:    f[^io͌pj
//    a_im:    f[^io͌pj
//    inv:    1: FesC-1: tFes
//    X_EXP:  ex:        f[^Q̗ݏŗ^܂(2exj
//    Y_EXP:  ey:        f[^Q̗ݏŗ^܂(2eyj
//-----------------------------------------------------------------------------
procedure TForm1.FFT2(var a_rl, a_im: D2array; inv, Y_EXP, X_EXP: Integer);
var
  b_rl      : D2array;              // f[^]uƗpzij
  b_im      : D2array;              // f[^]uƗpzi)
  hsin_tbl  : array of Double;      // pSINvZpe[u
  hcos_tbl  : array of Double;      // pCOSvZpe[u
  vsin_tbl  : array of Double;      // pSINvZpe[u
  vcos_tbl  : array of Double;      // pCOSvZpe[u
  buf_x     : array of Double;      // Ɨpobt@ij
  buf_y     : array of Double;      // Ɨpobt@ij
  i         : Integer;
begin
  // z̊m
  SetLength(b_rl, GWidth, GHeight);
  SetLength(b_im, GWidth, GHeight);
  SetLength(hsin_tbl, GWidth);
  SetLength(hcos_tbl, GWidth);
  SetLength(vsin_tbl, GHeight);
  SetLength(vcos_tbl, GHeight);
  SetLength(buf_x, GWidth);
  SetLength(buf_y, GHeight);
  cstb(GWidth,  inv, hsin_tbl, hcos_tbl);     // pSIN,COSe[u쐬
  cstb(GHeight, inv, vsin_tbl, vcos_tbl);     // pSIN,COSe[u쐬
  // ̂ees
  for i := 0 to GHeight - 1 do
    fft1core(@a_rl[i][0], @a_im[i][0], GWidth, X_EXP, inv, @hsin_tbl[0], @hcos_tbl[0], @buf_x[0]);
  // Qf[^̓]u
  rvmtx1(a_rl, b_rl, GWidth, Gheight);
  rvmtx1(a_im, b_im, GWidth, Gheight);
  // ̂ees
  for i := 0 to GWidth - 1 do
    fft1core(@b_rl[i][0], @b_im[i][0], GHeight, Y_EXP, inv, @vsin_tbl[0], @vcos_tbl[0], @buf_y[0]);
  //* Qf[^̓]u
  rvmtx2(b_rl, a_rl, GWidth, GHeight);
  rvmtx2(b_im, a_im, GWidth, GHeight);
end;


//---------------- KEVApf[^[̌vZ -------------------------------------
// VO}̒lŃKEXžvZ܂
// gaus̒lɂAz̑傫ς܂A܂傫Ăʂ͕ς܂
//---------------------------------------------------------------------------------
function TForm1.SigumaMatSet: boolean;
const
  MatSize = gaus;
var
  X, Y  : integer;
  KS, Z : Double;
  CH    : integer;
  Total : Double;
  MDIV2 : integer;

  // VO}lKEXzľvZ
  function Maskdatacalc(X, Y : Integer; Z: Double): double;
  begin
    Result := 1 / 2 * pi / Z / Z * Exp(-(X * X + Y * Y) / 2 / Z / Z);
  end;

begin
  Result := False;
  if (RadioGroup1.ItemIndex = Gaussians)
        or (RadioGroup1.ItemIndex = Deconvolution) then val(SigumaEdit.Text, Z, CH)
                                                   else val(UnsharpEdit.Text, Z, CH);
  if CH <> 0 then begin
    application.MessageBox(' ͂ɊԈႢ܂B','',0);
    exit;
  end;
  if Z <= 0 then begin
    application.MessageBox(' [ y [ȉł͂܂B','',0);
    exit;
  end;
  if RadioGroup1.ItemIndex = Deconvolution then begin
    val(RangeEdit.Text, threshold, CH);
    if CH <> 0 then begin
      application.MessageBox('Deconv Range ͂ɊԈႢ܂B','',0);
      exit;
    end;
  end;
  setlength(Gaussian, gaus, gaus);
  // XgOObh̐ݒ
  SigumaGrid.ClientWidth  := (SigumaGrid.DefaultColWidth + 1)  * (MatSize + 1) - 1;
  SigumaGrid.ColCount := MatSize + 1;
  SigumaGrid.ClientHeight := (SigumaGrid.DefaultRowHeight + 1) * (MatSize + 1) - 1;
  SigumaGrid.RowCount := MatSize + 1;
  // ŒZɃio[O
  MDIV2 := MatSize div 2;
  for Y := - MDIV2 to MDIV2 do SigumaGrid.Cells[0 , Y + MDIV2 + 1] := intTostr(Y);
  for X := - MDIV2 to MDIV2 do SigumaGrid.Cells[X + MDIV2 + 1,  0] := intTostr(X);

  // ВlɂAV[vtB^[f[^[vZƕ\
  Total := 0;
  for Y := - MDIV2 to MDIV2 do
    for X := - MDIV2 to MDIV2 do begin
      KS := Maskdatacalc( X, Y, Z);
      Gaussian[X + MDIV2, Y + MDIV2] := KS;
      // vvZ
      Total := Total + KS;
    end;
  // GaussiantB^[̒lϊ vlPɂȂ悤ɕϊ܂
  for Y := - MDIV2 to MDIV2 do
    for X := - MDIV2 to MDIV2 do begin
      KS := Gaussian[X + MDIV2, Y + MDIV2] / Total;
      Gaussian[X + MDIV2, Y + MDIV2] := KS;
      // Obhɕ\
      SigumaGrid.Cells[X  + MDIV2 + 1, Y + MDIV2 + 1] := FloatTostrF(KS, ffFixed, 6,5);
    end;
  application.ProcessMessages;
  Result := True;
end;

procedure TForm1.SharpnessMask;
var
  x, y  : integer;
  MDIV2 : integer;
  C, at : Double;
  check : integer;
begin
  setlength(sharparray, sharp, sharp);
  val(SharpnessEdit.Text, C, check);
  if check <> 0 then begin
    application.MessageBox('Sharpness Sl͂ɊԈႢ܂B','',0);
    exit;
  end;
  if C < 1 then begin
    application.MessageBox('Sharpness Sl Pȉł͂܂B','',0);
    exit;
  end;
  MDIV2 := sharp div 2;
  at := (C - 1) / 8;
  for x := 0 to sharp - 1 do
    for y := 0 to sharp - 1 do sharparray[y, x] := - at;
      sharparray[MDIV2 , MDIV2] := C;
  // XgOObh̐ݒ
  SharpnessGrid.ClientWidth  := (SharpnessGrid.DefaultColWidth + 1)  * (sharp + 1) - 1;
  SharpnessGrid.ColCount := sharp + 1;
  SharpnessGrid.ClientHeight := (SharpnessGrid.DefaultRowHeight + 1) * (sharp + 1) - 1;
  SharpnessGrid.RowCount := sharp + 1;
  // ŒZɃio[O
  for y := - MDIV2 to MDIV2 do SharpnessGrid.Cells[0 , Y + MDIV2 + 1] := intTostr(Y);
  for x := - MDIV2 to MDIV2 do SharpnessGrid.Cells[X + MDIV2 + 1,  0] := intTostr(X);
  // tB^[l\
  for x := 0 to sharp - 1 do
    for y := 0 to sharp - 1 do begin
      SharpnessGrid.Cells[x + 1, y + 1] := FloatTostrF(sharparray[x , y], ffFixed, 5,4);
    end;
  application.ProcessMessages;
end;

var
  conv_real   : D2array;             // vVAAKEXtB^[p
  conv_image  : D2array;             // vVAAKEXtB^[p
  half_cw     : integer;
  half_ch     : integer;
  arBlu       : D2array;             // f[^io͌p)
  aiBlu       : D2array;             // f[^io͌p)
  r, i        : Double;
  data        : Double;
  PBA         : PByteArray;
  WP, DI      : Integer;
  rdr         : Double;

//------------------------------
// tB^[vZI
//------------------------------
procedure TForm1.MaskingBtnClick(Sender: TObject);
begin
  if Timer1.Enabled = False then begin
    RepaintBtn.Enabled := False;
    FileOpenBtn.Enabled := False;
    FileSaveBtn.Enabled := False;
    MaskingBtn.Enabled := False;
    sourceBtn.Enabled := False;
    TimerF := 1;
    Timer1.Enabled := True;
  end
  else
    exit;
end;

//---------------------------------------
// {^Aj[V҂킹^C}[
//---------------------------------------
procedure TForm1.Timer1Timer(Sender: TObject);
begin
  Timer1.Enabled := False;
  case TimerF of
    0: begin
         SigumaMatSet;
         SharpnessMask;
         TimerF := 1;
       end;
    1: begin
         if RadioGroup1.ItemIndex = Laplacian  then LaplacianMask;
         if (RadioGroup1.ItemIndex = Gaussians) or
            (RadioGroup1.ItemIndex = Deconvolution) or
            (RadioGroup1.ItemIndex = Unsharp) or
            (RadioGroup1.ItemIndex = Sharpness) then GaussianRoutine;
         FileSaveBtn.Enabled := True;
         FileOpenBtn.Enabled := True;
         RepaintBtn.Enabled := True;
         radiogroup1.Enabled := True;
         sourceBtn.Enabled := True;
       end;
  end;
end;

procedure TForm1.Masking(mask: D2array; size :integer);
var
  nx, ny, x, y: integer;
begin
  setlength(conv_real,  GHeight, GWidth);
  setlength(conv_image, GHeight, GWidth);
  setlength(arBlu, GHeight, GWidth);
  setlength(aiBlu, GHeight, GWidth);
  // z̃NA
  for y := 0 to GHeight - 1 do
    for x := 0 to GWidth - 1 do begin
      conv_real[Y, X] := 0;
      conv_image[Y, X] := 0;
    end;
  // vVA,KEVAtB^[̐ݒ
  // gtB^[̐ݒ
  half_cw := size div 2;
  half_ch := size div 2;
  for y := 0 to size - 1 do
    for x := 0 to size -1 do  begin
      nx := GWidth - half_cw + x;
      ny := Gheight - half_ch + y;
      if nx >= GWidth   then nx := nx - GWidth;
      if ny >= Gheight  then ny := ny - GHeight;
      conv_real[ny][nx] := mask[y][x];
    end;
  // gtB^[t[Gϊ܂
  // @tB^[̏ꍇAϊAf[^[ɂ鏜ZȂ悤ɂ܂
  fft2(conv_real, conv_image, 2, Y_EXP, X_EXP);
end;

//------------------------------------------
// vVAvZ
//------------------------------------------
procedure TForm1.LaplacianMask;
// vVAtB^[
//    (1,  1,  1)
//    (1, -8,  1)
//    (1,  1,  1)
const
  cvnLap  = 3;
var
  x, y    : integer;
  convLap : D2array;
begin
  // z̊m
  setlength(convLap, cvnLap, cvnLap);
  for x := 0 to cvnLap - 1 do
    for y := 0 to cvnLap - 1 do convLap[y, x] := 1;
  convLap[ 1, 1] := -8;
  // tB^[ƃtB^[̂Qees
  Masking(convLap, cvnLap);
  // 摜ǂݍ݁CQees̓̓f[^ɕϊ܂
  for y := 0 to GHeight - 1 do
    for x := 0 to GWidth - 1 do begin
      arBlu[y, x] := GryMAT[y][x];
      aiBlu[y, x] := 0.0;
    end;
  // Qeess 摜gɕϊ܂
  fft2(arBlu, aiBlu, 1, Y_EXP, X_EXP);
  // vVA tB^[
  for x := 0 to GWidth - 1 do
    for y := 0 to GHeight - 1 do begin
      // tB^[̎{
      r := arBlu[y][x] * conv_real[y][x]  - aiBlu[y][x] * conv_image[y][x];
      i := arBlu[y][x] * conv_image[y][x] + aiBlu[y][x] * conv_real[y][x];
      arBlu[y][x] := r;
      aiBlu[y][x] := i;
    end;
  // teessāCtB^ꂽg摜ɖ߂܂
  fft2(arBlu, aiBlu, -1, Y_EXP, X_EXP );
  // ʂ摜f[^ɕϊ
  for Y := 0 to Gheight - 1 do begin
    PBA := OutputBitmap.ScanLine[Y];
    for X := 0 to GWidth - 1 do begin
      WP := X * 3;
      data := arBlu[y, x];
      if data > 255 then data := 255;
      if data <   0 then data := 0;
      DI := Round(data);
      PBA[WP]     := DI;
      PBA[WP + 1] := DI;
      PBA[WP + 2] := DI;
    end;
  end;
  Imageout(OutputBitmap);               // o͘gɕϔ{o
end;

//------------------------------------------
// KEXtB^[ɂ{PvZ  Gaussian
// fR{[V        Deconvolution
// AV[v                Unsharp
//------------------------------------------
procedure TForm1.GaussianRoutine;
var
  x, y  : integer;
  Step  : integer;
  K     : Double;
  check : integer;
begin
  K := 1;
  if RadioGroup1.ItemIndex = Unsharp then begin
    val(UnsharpKEdit.Text, K, check);
    if check <> 0 then begin
      application.MessageBox('AV[vWlł܂B','',0);
      exit;
    end;
  end;
  if RadioGroup1.ItemIndex <> Sharpness then begin
    // KEVAtB^[f[^[̐
    if not SigumaMatSet then exit;
    // tB^[ƃtB^[̂Qees
    Masking(Gaussian, gaus);
  end
  else begin
    SharpnessMask;
    // tB^[ƃtB^[̂Qees
    Masking(sharparray, sharp);
  end;
  // FOFJԂ܂
  for Step := 0 to 2 do begin
    // 摜Qees̓̓f[^ɕϊ܂
    for y := 0 to GHeight - 1 do
      for x := 0 to GWidth - 1 do begin
        case Step of
          0 : arBlu[y, x] := BluMAT[y][x];
          1 : arBlu[y, x] := GrnMat[y][x];
          2 : arBlu[y, x] := RedMat[y][x];
        end;
        aiBlu[y, x] := 0.0;
      end;
    // Qeess 摜gɕϊ܂
    fft2(arBlu, aiBlu, 1, Y_EXP, X_EXP);

    // KEVA tB^[ {JV --------------------------------
    if (RadioGroup1.ItemIndex = Gaussians) or
       (RadioGroup1.ItemIndex = Sharpness) then begin
      for x := 0 to GWidth - 1 do
        for y := 0 to GHeight - 1 do begin
          // tB^[̎{
          r := arBlu[y][x] * conv_real[y][x]  - aiBlu[y][x] * conv_image[y][x];
          i := arBlu[y][x] * conv_image[y][x] + aiBlu[y][x] * conv_real[y][x];
          arBlu[y][x] := r;
          aiBlu[y][x] := i;
        end;
    end;
    //--------------------------------------------------------------

    // fR{[V ----------------------------------------
    if RadioGroup1.ItemIndex = Deconvolution then begin
      for x := 0 to GWidth - 1 do
        for y := 0 to GHeight - 1 do begin
          // fR{[VW
          // conv_image̒l͔ɏ̂Ōʂɖwǉe܂B
//          rdr := conv_real[y][x] * conv_real[y][x] + conv_image[y][x] * conv_image[y][x];
          rdr := sqrt(conv_real[y][x] * conv_real[y][x] + conv_image[y][x] * conv_image[y][x]);
          if rdr > threshold then rdr := 1 / rdr
                             else rdr := 0;
          // fR{[V̐
          r := (arBlu[y][x] - aiBlu[y][x]) * rdr;
          i := (arBlu[y][x] + aiBlu[y][x]) * rdr;
          arBlu[y][x] := r;
          aiBlu[y][x] := i;
        end;
    end;
    //--------------------------------------------------------------

    // AV[v --------------------------------------------
    if RadioGroup1.ItemIndex = Unsharp then begin
      for x := 0 to GWidth - 1 do
        for y := 0 to GHeight - 1 do begin
          // {P摜̐
          r := arBlu[y][x] * conv_real[y][x]  - aiBlu[y][x] * conv_image[y][x];
          i := arBlu[y][x] * conv_image[y][x] + aiBlu[y][x] * conv_real[y][x];
          // vZ
          r := arBlu[y][x] - r;
          i := aiBlu[y][x] - i;
          // f[^[ɍZ
          arBlu[y][x] := arBlu[y][x] + r * k;
          aiBlu[y][x] := aiBlu[y][x] + i * k;
        end;
    end;
    //--------------------------------------------------------------

    // teessāCtB^ꂽg摜ɖ߂܂
    fft2(arBlu, aiBlu, -1, Y_EXP, X_EXP );
    // ʂ摜f[^ɕϊ
    for Y := 0 to Gheight - 1 do begin
      PBA := OutputBitmap.ScanLine[Y];
      for X := 0 to GWidth - 1 do begin
        WP := X * 3;
        data := arBlu[y, x];
        if data > 255 then data := 255;
        if data <   0 then data := 0;
        DI := Round(data);
        case Step of
          0 : PBA[WP]     := DI;
          1 : PBA[WP + 1] := DI;
          2 : PBA[WP + 2] := DI;
        end;
      end;
    end;
  end;
  Imageout(OutputBitmap);               // o͘gɕϔ{o
end;

//---------------------
// 摜̕\
//---------------------
procedure TForm1.sourceBtnClick(Sender: TObject);
begin
  Imageout(InputDBitmap);               // o͘gɕϔ{o
end;

//-----------------------
// tB^[{^Cl[u
//-----------------------
procedure TForm1.RadioGroup1Click(Sender: TObject);
begin
  MaskingBtn.Enabled := True;
end;

procedure TForm1.RangeEditChange(Sender: TObject);
begin
  MaskingBtn.Enabled := True;
end;

procedure TForm1.UnsharpEditChange(Sender: TObject);
begin
  MaskingBtn.Enabled := True;
end;

procedure TForm1.UnsharpKEditChange(Sender: TObject);
begin
  MaskingBtn.Enabled := True;
end;

procedure TForm1.SigumaEditChange(Sender: TObject);
begin
  MaskingBtn.Enabled := True;
end;

procedure TForm1.SharpnessEditChange(Sender: TObject);
begin
  MaskingBtn.Enabled := True;
end;

//----------------------------
// vZʂ̍ĕ\
//----------------------------
procedure TForm1.RepaintBtnClick(Sender: TObject);
begin
  Imageout(OutputBitmap);               // o͘gɕϔ{o
end;

//---------------------------------------------------
// t@C̃I[vƃOCf[^[ƃJ[̐
//---------------------------------------------------
procedure TForm1.FileOpenBtnClick(Sender: TObject);
var
  WIC         : TWICImage;
  X, Y        : Integer;
  PBA         : PBytearray;
  WP          : Integer;
  nx2         : Integer;
  XF, YF      : Boolean;
begin
  VRect := Rect(0, 0, Image1.Width, Image1.Height);
  Image1.Canvas.Brush.Style := bsSolid;
  Image1.Canvas.Brush.Color := clBtnface;
  Image1.Canvas.FillRect(VRect);                              // Canvas 摜
  OpenPictureDialog1.Filter := OpenFileFilter;                // t@CI[vtB^[̐ݒ
  if OpenPictureDialog1.Execute = true then                          // t@Cw肳ꂽ
    begin
      WIC := TWICImage.Create;                                // TWICImage̐
      try
        InFilename := OpenPictureDialog1.FileName;            // t@C̎擾
        WIC.LoadFromFile(InFilename);                         // 摜̓ǂݍ
        GHeight := WIC.Height;                                // 摜擾
        GWidth  := WIC.Width;                                 // 摜
        Image1.Width := GWidth;
        Image1.Height:= GHeight;
        Image1.Picture.Bitmap.SetSize(GWidth, GHeight);
        InputDBitmap.Width := GWidth;
        InputDBitmap.Height := GHeight;
        InputDBitmap.Canvas.Draw(0, 0, WIC);                  // rbg}bvɕ`tH[}bgϊ
//        InputDBitmap.Assign(WIC);                             // Tbitmap  TWICImageRs[
      finally
        WIC.Free;                                             // TWICImage 
      end;
    end
    else exit;
  OutputBitmap.Width  := GWidth;
  OutputBitmap.Height := GHeight;
  setLength(GryMat, GHeight, GWidth);
  setLength(RedMat, GHeight, GWidth);
  setLength(GrnMat, GHeight, GWidth);
  setLength(BluMat, GHeight, GWidth);
  // J[
  for Y := 0 to Gheight - 1 do begin
    PBA := InputDBitmap.ScanLine[Y];
    for X := 0 to GWidth - 1 do begin
      WP := X * 3;
      // vVApOC摜
      GryMat[Y][X] := Round(PBA[WP] * kb + PBA[WP + 1] * kg + PBA[WP + 2] * kr); // Pxϊ
      // J[pOF
      BluMAT[Y, X] := PBA[WP];
      GrnMAT[Y, X] := PBA[WP + 1];
      RedMAT[Y, X] := PBA[WP + 2];
    end;
  end;
  Imageout(InputDBitmap);               // o͘gɕϔ{o
  XF := False;
  YF := False;
  nx2 := 1;
  repeat
    nx2 := nx2 * 2;
    if nx2 = GWidth then XF := True;
    if nx2 = GHeight then YF := True;
  until (nx2 > GWidth) and (nx2 > GHeight);
  if not XF or not YF  then begin
    if not XF then application.MessageBox('摜̑傫Q̗ݏł͂܂B','',0);
    if not YF then application.MessageBox('摜̑傫Q̗ݏł͂܂B','',0);
    exit;
  end;
  // f[^̂Qׂ̂vZ
  X_EXP := 0;
  nx2 := 1;
  for X := 0 to GWidth do begin
    nx2 := nx2 * 2;
    if nx2 > GWidth then begin
      X_EXP := X;
      break;
    end;
  end;
  // f[^̂Qׂ̂vZ
  Y_EXP := 0;
  nx2 := 1;
  for Y := 0 to GHeight do begin
    nx2 := nx2 * 2;
    if nx2 > GHeight then begin
      Y_EXP := Y;
      break;
    end;
  end;
  MaskingBtn.Enabled := True;
  sourceBtn.Enabled := True;
  radiogroup1.Enabled := True;
end;

//------------------------------
// 摜̃t@Cւ̕ۑ
//------------------------------
procedure TForm1.FileSaveBtnClick(Sender: TObject);
var
  WIC     : TWicImage;
  WICF    : TWicImageFormat;

  Fname   : String;
  ExeStr  : String;
  FnameTop: String;
  Findex  : integer;

  function WFormatSet: Boolean;                                            // gqɂt@CtH[}bgݒ
  begin
    Result := false;
    ExeStr := LowerCase(ExeStr);
    if ExeStr = '.jpg'  then  begin WICF := Wifjpeg; Result := True; end;
    if ExeStr = '.jpeg' then  begin WICF := Wifjpeg; Result := True; end;
    if ExeStr = '.tif'  then  begin WICF := Wiftiff; Result := True; end;
    if ExeStr = '.tiff' then  begin WICF := Wiftiff; Result := True; end;
    if ExeStr = '.png'  then  begin WICF := Wifpng;  Result := True; end;
    if ExeStr = '.gif'  then  begin WICF := Wifgif;  Result := True; end;
    if ExeStr = '.bmp'  then  begin WICF := Wifbmp;  Result := True; end;
    if ExeStr = '.wdp'  then  begin WICF := WifWMPhoto; Result := True; end;
    if ExeStr = '.hdp'  then  begin WICF := WifWMPhoto; Result := True; end;
  end;

begin
  SavePictureDialog1.Filter := SaveFileFilter;
//  SavePictureDialog1.DefaultExt := GraphicExtension(TWicImage);
  if not SavePictureDialog1.Execute then exit;
  ExeStr := ExtractFileExt(SavePictureDialog1.FileName);
  if ExeStr = '' then begin                                                // gqȂ
    Findex := SavePictureDialog1.FilterIndex;                              // FilterIndexɂgq̐ݒ
    case Findex of
      1, 3 : Fname := ChangeFileExt(SavePictureDialog1.FileName,'.jpg');   // gq̐ݒ
         2 : Fname := ChangeFileExt(SavePictureDialog1.FileName,'.png');   // gq̐ݒ
         4 : Fname := ChangeFileExt(SavePictureDialog1.FileName,'.gif');   // gq̐ݒ
         5 : Fname := ChangeFileExt(SavePictureDialog1.FileName,'.bmp');   // gq̐ݒ
         6 : Fname := ChangeFileExt(SavePictureDialog1.FileName,'.tif');   // gq̐ݒ
         7 : Fname := ChangeFileExt(SavePictureDialog1.FileName,'.wdp');   // gq̐ݒ
    end;
  end
  else
    Fname := SavePictureDialog1.FileName;
  ExeStr := ExtractFileExt(Fname);                                         // gqo
  if not WFormatSet then begin                                             // gqɂt@CtH[}bgݒƊmF
    application.MessageBox('t@C̊gqԈĂ܂B','', 0);
    exit;
  end;
  FnameTop := ExtractFileName(Fname);                                      // t@Co
  if Length(FnameTop) = Length(ExeStr) then begin                          // t@C̒mF
    application.MessageBox('t@C܂B','', 0);
    exit;
  end;

  if FileExists(Fname) then                                                // t@Cɂt@C
    if MessageDlg('ɓÕt@C܂㏑܂ ' + ExtractFileName(Fname) + '?',
                                                      mtConfirmation, [mbYes, mbNo], 0, mbNo) = IDNo then exit;

  WIC := TWicImage.Create;                                                 // TWicImage
  try
    WIC.Assign(OutputBitmap);                                              // TWicImageɃrbg}bvf[^[t
    WIC.ImageFormat := WICF;                                               // ۑtH[}bgZbg
    WIC.SaveTofile(Fname);                                                 // t@C̏o
  finally
    WIC.Free;                                                              // TWicImage
  end;
end;

//----------------
// ݒ
//----------------
procedure TForm1.FormCreate(Sender: TObject);
begin
  Timer1.Enabled := False;
  Image1.Width  := ImageHWC div 2;
  Image1.Height := ImageHWC div 2;
  ScrollBox1.Height := ImageHWC;
  ScrollBox1.Width  := ImageHWC;
  Image1.Top := 0;
  Image1.Left := 0;
  InputDBitmap  := TBitmap.Create;
  OutputBitmap  := TBitmap.Create;
  InputDBitmap.PixelFormat := pf24bit;
  OutputBitmap.PixelFormat := pf24bit;
  radiogroup1.Items.Add('Laplacian');
  radiogroup1.Items.Add('Gaussian');
  radiogroup1.Items.Add('Deconvolution');
  radiogroup1.Items.Add('Unsharp');
  radiogroup1.Items.Add('Sharpness');
  radiogroup1.ItemIndex := 4;
  radiogroup1.Enabled := False;
  MaskingBtn.Enabled := False;
  FileSaveBtn.Enabled := False;
  sourceBtn.Enabled := False;
  RepaintBtn.Enabled := False;
  TimerF := 0;
  Timer1.Enabled := True;
end;

//----------------
// I
//----------------
procedure TForm1.FormDestroy(Sender: TObject);
begin
  InputDBitmap.Free;
  OutputBitmap.Free;
end;


end.
