unit Main;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.ExtCtrls, Vcl.StdCtrls, Vcl.Extdlgs, Vcl.grids,
  System.UITypes, System.Math;

type
  B2array = array of array of Byte;
  D2array = array of array of Double;

  TForm1 = class(TForm)
    FileOpenBtn: TButton;
    ScrollBox1: TScrollBox;
    Image1: TImage;
    OpenPictureDialog1: TOpenPictureDialog;
    magnificationEdit: TLabeledEdit;
    SharpnessGrid: TStringGrid;
    SharpnessEdit: TLabeledEdit;
    Timer1: TTimer;
    RepaintBtn: TButton;
    MaskingBtn: TButton;
    sourceBtn: TButton;
    FileSaveBtn: TButton;
    SavePictureDialog1: TSavePictureDialog;
    RadioGroup1: TRadioGroup;
    procedure FileOpenBtnClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure RepaintBtnClick(Sender: TObject);
    procedure MaskingBtnClick(Sender: TObject);
    procedure FileSaveBtnClick(Sender: TObject);
    procedure sourceBtnClick(Sender: TObject);
    procedure SharpnessEditChange(Sender: TObject);
    procedure RadioGroup1Click(Sender: TObject);
  private
    { Private 錾 }
    procedure Imageout(Image: TBitmap);
    procedure SharpnessMask;
    procedure Masking;
    procedure ScanArray;
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

const
  OpenFileFilter =
    '摜t@C|*.png;*.jpg;*.gif;*.bmp;*.tif;*.ico;*.wdp'+
    '|*.png|*.png' +
    '|*.jpg|*.jpg' +
    '|*.gif|*.gif' +
    '|*.bmp|*.bmp' +
    '|*.tif|*.tif' +
    '|*.ico|*.ico' +
    '|*.wdp|*.wdp';

  SaveFileFilter =
    '摜t@C|*.png;*.jpg;*.gif;*.bmp;*.tif;*.wdp' +
    '|*.png|*.png' +
    '|*.jpg|*.jpg' +
    '|*.gif|*.gif' +
    '|*.bmp|*.bmp' +
    '|*.tif|*.tif' +
    '|*.wdp|*.wdp';

  ImageHWC   = 440;    // \gTCY

var
  InputDBitmap  : TBitmap;                    // ̓f[^[\prbg}bv
  OutputBitmap  : TBitmap;                    // ]摜\prbg}bv
  GHeight       : Integer;                    // ̓f[^[摜
  GWidth        : Integer;                    // ̓f[^[摜
  MGHeight      : Integer;                    // ̓f[^[摜
  MGWidth       : Integer;                    // ̓f[^[摜

  VRect         : Trect;                      // \TCYݒp
  InFilename    : string;                     // ̓t@C

  RedMat        : B2array;
  GrnMat        : B2array;
  BluMat        : B2array;
  sharparray    : D2array;
  arBlu         : D2array;                    // f[^io͌p)
  aiBlu         : D2array;                    // f[^io͌p)
  TimerF        : Byte;
  sharp         : integer;
  scand         : array of integer;

// zXLpz̍쐬
procedure TForm1.ScanArray;
var
  MDIV2, x: integer;
begin
  case RadioGroup1.ItemIndex of
    0: sharp := 3;
    1: sharp := 5;
    2: sharp := 7;
  end;
  setlength(scand, sharp);
  MDIV2 := sharp div 2;
  // -----XLz̍쐬-------
  for x := - MDIV2 to MDIV2 do scand[x + MDIV2] := x;
end;

//-------------------------------------------
// V[vlXtB^[쐬
// tB^[̒l̍vPɂȂ悤ɂ܂
// a ̒l͕ɐݒ܂B
// a a a
// a c a
// a a a
// a = - (c - 1) / 8
//-------------------------------------------
procedure TForm1.SharpnessMask;
var
  x, y  : integer;
  MDIV2 : integer;
  ad    : double;
  C, at : Double;
  check : integer;
  Tsharp : Double;
begin
  setlength(sharparray, sharp, sharp);
  val(SharpnessEdit.Text, C, check);
  if check <> 0 then begin
    application.MessageBox('Sharpness Sl͂ɊԈႢ܂B','',0);
    exit;
  end;
  if C < 0 then begin
    application.MessageBox('Sharpness Sl Oȉł͂܂B','',0);
    exit;
  end;
  // ----V[vlXz̍쐬----
  MDIV2 := sharp div 2;
  Tsharp := 0;
  for y := - MDIV2 to MDIV2 do
    for x := - MDIV2 to MDIV2 do begin
      // ̎敪̈vZ z̒l͂O
      if (x = 0) and (y = 0) then ad := 0
                             else ad := 1 / (y * y +  x * x);
      // zɕۑ
      sharparray[y + MDIV2 , X + MDIV2] := ad;
      // vlvZ
      Tsharp := Tsharp + ad;
    end;
  // vl-(C-P)ɂȂ悤ɕ␳
  at := - (C - 1) / Tsharp;
  for y := 0 to sharp - 1 do
    for x := 0 to sharp - 1 do
      sharparray[x, y] := sharparray[x, y] * at;
  // z̒l b Zbg
  sharparray[MDIV2 , MDIV2] := C;
  // ------------------------------
  // XgOObh̐ݒ
  SharpnessGrid.ClientWidth  := (SharpnessGrid.DefaultColWidth + 1)  * (sharp + 1) - 1;
  SharpnessGrid.ColCount := sharp + 1;
  SharpnessGrid.ClientHeight := (SharpnessGrid.DefaultRowHeight + 1) * (sharp + 1) - 1;
  SharpnessGrid.RowCount := sharp + 1;
  // ŒZɃio[O
  for y := - MDIV2 to MDIV2 do SharpnessGrid.Cells[0 , Y + MDIV2 + 1] := intTostr(Y);
  for x := - MDIV2 to MDIV2 do SharpnessGrid.Cells[X + MDIV2 + 1,  0] := intTostr(X);
  // V[vlXtB^[l̕\
  for x := 0 to sharp - 1 do
    for y := 0 to sharp - 1 do begin
      SharpnessGrid.Cells[x + 1, y + 1] := FloatTostrF(sharparray[x , y], ffFixed, 5,4);
    end;
  application.ProcessMessages;
end;

//------------------------
// ϔ{o
//------------------------
procedure TForm1.Imageout(Image: TBitmap);
var
  Rect0           : Trect;
  magnification   : Double;
  Check           : Integer;
  MW, MH          : Integer;
begin
  Val(magnificationEdit.Text,magnification,Check);
  if Check <> 0 then begin
    application.MessageBox('\{͂ɊԈႢ܂B','',0);
    exit;
  end;
  MW := Round(GWidth * magnification);
  MH := Round(GHeight * magnification);
  Rect0 := Rect(0, 0, MW, MH);
  Image1.Width := MW;
  Image1.Height := MH;
  Image1.Picture.Bitmap.SetSize(MW, MH);
  Image1.Canvas.StretchDraw(Rect0, Image);                // o͘gɕϔ{o
end;

//----------------------------------
// V[vlX
//----------------------------------
procedure TForm1.Masking;
var
  x, y       : integer;
  mx, my     : integer;
  dx, dy     : integer;
  Step       : integer;
  data       : Double;
  PBA        : PByteArray;
  DI         : Byte;
  WP         : integer;
begin
  ScanArray;
  SharpnessMask;                            // V[vlXtB^[̐
  for Step := 0 to 2 do begin
    for y := 0 to MGHeight do
      for x := 0 to MGWidth do begin
        case Step of
          0 : arBlu[y, x] := BluMAT[y][x];
          1 : arBlu[y, x] := GrnMat[y][x];
          2 : arBlu[y, x] := RedMat[y][x];
        end;
        aiBlu[y, x] := 0.0;
      end;
    // ----- V[vlXvZ -------
    for y := 0 to MGHeight do
      for x := 0 to MGWidth do begin
        for my := 0 to sharp - 1 do begin
          dy := y + scand[my];
          if dy < 0        then dy := - dy;
          if dy > MGHeight then dy := MGheight - scand[my];
          for mx := 0 to sharp - 1 do begin
            dx := x + scand[mx];
            if dx < 0       then dx := - dx;
            if dx > MGWidth then dx := MGWidth - scand[mx];
            aiBlu[y, x] := aiBlu[y, x] + arBlu[dy, dx] * sharparray[my, mx];
          end;
        end;
    end;
    // ------------------------------
    for Y := 0 to MGheight do begin
      PBA := OutputBitmap.ScanLine[Y];
      for X := 0 to MGWidth do begin
        WP := X * 3;
        data := aiBlu[y, x];
        if data > 255 then data := 255;
        if data <   0 then data := 0;
        DI := Round(data);
        case Step of
          0 : PBA[WP]     := DI;
          1 : PBA[WP + 1] := DI;
          2 : PBA[WP + 2] := DI;
        end;
      end;
    end;
  end;
  Imageout(OutputBitmap);               // o͘gɕϔ{o
  FileSaveBtn.Enabled := True;
  RepaintBtn.Enabled := True;
  sourceBtn.Enabled := True;
  MaskingBtn.Enabled := False;
end;

//-------------------------------
// V[vlXN
//-------------------------------
procedure TForm1.MaskingBtnClick(Sender: TObject);
begin
  FileSaveBtn.Enabled := False;
  RepaintBtn.Enabled := False;
  MaskingBtn.Enabled := False;
  sourceBtn.Enabled := False;
  Timer1.Enabled := True;
end;

//----------------------------
// vZʂ̍ĕ\
//----------------------------
procedure TForm1.RepaintBtnClick(Sender: TObject);
begin
  Imageout(OutputBitmap);               // o͘gɕϔ{o
end;

//----------------------------------
// \[X摜̕\
//----------------------------------
procedure TForm1.sourceBtnClick(Sender: TObject);
begin
  Imageout(InputDBitmap);               // o͘gɕϔ{o
end;

//-----------------------------------
// ŌvZ̈ }XN{^Cl[u
//-----------------------------------
procedure TForm1.SharpnessEditChange(Sender: TObject);
begin
  MaskingBtn.Enabled := True;
end;

procedure TForm1.RadioGroup1Click(Sender: TObject);
begin
  MaskingBtn.Enabled := True;
end;

//-------------------------------
// \vZ^C~O̐
//-------------------------------
procedure TForm1.Timer1Timer(Sender: TObject);
begin
  Timer1.Enabled := False;
  case TimerF of
    0 : begin
          ScanArray;
          SharpnessMask;
          TimerF := 1;
        end;
    1: Masking;
  end;
end;

//---------------------------------------------------
// t@C̃I[v J[f[^[̐
//---------------------------------------------------
procedure TForm1.FileOpenBtnClick(Sender: TObject);
var
  WIC         : TWICImage;
  X, Y        : Integer;
  PBA         : PBytearray;
  WP          : Integer;
begin
  VRect := Rect(0, 0, Image1.Width, Image1.Height);
  Image1.Canvas.Brush.Style := bsSolid;
  Image1.Canvas.Brush.Color := clBtnface;
  Image1.Canvas.FillRect(VRect);                              // Canvas 摜
  OpenPictureDialog1.Filter := OpenFileFilter;                // t@CI[vtB^[̐ݒ
  if OpenPictureDialog1.Execute = true then                          // t@Cw肳ꂽ
    begin
      WIC := TWICImage.Create;                                // TWICImage̐
      try
        InFilename := OpenPictureDialog1.FileName;            // t@C̎擾
        WIC.LoadFromFile(InFilename);                         // 摜̓ǂݍ
        GHeight := WIC.Height;                                // 摜擾
        GWidth  := WIC.Width;                                 // 摜
        Image1.Width := GWidth;
        Image1.Height:= GHeight;
        Image1.Picture.Bitmap.SetSize(GWidth, GHeight);
        InputDBitmap.Width := GWidth;
        InputDBitmap.Height := GHeight;
        InputDBitmap.Canvas.Draw(0, 0, WIC);                  // rbg}bvɕ`tH[}bgϊ
//        InputDBitmap.Assign(WIC);                             // Tbitmap  TWICImageRs[
      finally
        WIC.Free;                                             // TWICImage 
      end;
    end
    else exit;
  MGHeight := GHeight - 1;                                    // ̓f[^[摜
  MGWidth  := GWidth  - 1;                                    // ̓f[^[摜

  OutputBitmap.Width  := GWidth;
  OutputBitmap.Height := GHeight;
  setLength(RedMat, GHeight, GWidth);
  setLength(GrnMat, GHeight, GWidth);
  setLength(BluMat, GHeight, GWidth);
  setlength(arBlu, GHeight, GWidth);
  setlength(aiBlu, GHeight, GWidth);

  // J[
  for Y := 0 to MGheight do begin
    PBA := InputDBitmap.ScanLine[Y];
    for X := 0 to MGWidth do begin
      WP := X * 3;
      // vVApOC摜
      // J[pOF
      BluMAT[Y, X] := PBA[WP];
      GrnMAT[Y, X] := PBA[WP + 1];
      RedMAT[Y, X] := PBA[WP + 2];
    end;
  end;
  Imageout(InputDBitmap);               // o͘gɕϔ{o
  MaskingBtn.Enabled := True;
  sourceBtn.Enabled := True;
  RadioGroup1.Enabled := True;
end;

//------------------------------
// 摜̃t@Cւ̕ۑ
//------------------------------
procedure TForm1.FileSaveBtnClick(Sender: TObject);
var
  WIC     : TWicImage;
  WICF    : TWicImageFormat;

  Fname   : String;
  ExeStr  : String;
  FnameTop: String;
  Findex  : integer;

  function WFormatSet: Boolean;                                            // gqɂt@CtH[}bgݒ
  begin
    Result := false;
    ExeStr := LowerCase(ExeStr);
    if ExeStr = '.jpg'  then  begin WICF := Wifjpeg; Result := True; end;
    if ExeStr = '.jpeg' then  begin WICF := Wifjpeg; Result := True; end;
    if ExeStr = '.tif'  then  begin WICF := Wiftiff; Result := True; end;
    if ExeStr = '.tiff' then  begin WICF := Wiftiff; Result := True; end;
    if ExeStr = '.png'  then  begin WICF := Wifpng;  Result := True; end;
    if ExeStr = '.gif'  then  begin WICF := Wifgif;  Result := True; end;
    if ExeStr = '.bmp'  then  begin WICF := Wifbmp;  Result := True; end;
    if ExeStr = '.wdp'  then  begin WICF := WifWMPhoto; Result := True; end;
    if ExeStr = '.hdp'  then  begin WICF := WifWMPhoto; Result := True; end;
  end;

begin
  SavePictureDialog1.Filter := SaveFileFilter;
//  SavePictureDialog1.DefaultExt := GraphicExtension(TWicImage);
  if not SavePictureDialog1.Execute then exit;
  ExeStr := ExtractFileExt(SavePictureDialog1.FileName);
  if ExeStr = '' then begin                                                // gqȂ
    Findex := SavePictureDialog1.FilterIndex;                              // FilterIndexɂgq̐ݒ
    case Findex of
      1, 3 : Fname := ChangeFileExt(SavePictureDialog1.FileName,'.jpg');   // gq̐ݒ
         2 : Fname := ChangeFileExt(SavePictureDialog1.FileName,'.png');   // gq̐ݒ
         4 : Fname := ChangeFileExt(SavePictureDialog1.FileName,'.gif');   // gq̐ݒ
         5 : Fname := ChangeFileExt(SavePictureDialog1.FileName,'.bmp');   // gq̐ݒ
         6 : Fname := ChangeFileExt(SavePictureDialog1.FileName,'.tif');   // gq̐ݒ
         7 : Fname := ChangeFileExt(SavePictureDialog1.FileName,'.wdp');   // gq̐ݒ
    end;
  end
  else
    Fname := SavePictureDialog1.FileName;
  ExeStr := ExtractFileExt(Fname);                                         // gqo
  if not WFormatSet then begin                                             // gqɂt@CtH[}bgݒƊmF
    application.MessageBox('t@C̊gqԈĂ܂B','', 0);
    exit;
  end;
  FnameTop := ExtractFileName(Fname);                                      // t@Co
  if Length(FnameTop) = Length(ExeStr) then begin                          // t@C̒mF
    application.MessageBox('t@C܂B','', 0);
    exit;
  end;

  if FileExists(Fname) then                                                // t@Cɂt@C
    if MessageDlg('ɓÕt@C܂㏑܂ ' + ExtractFileName(Fname) + '?',
                                                      mtConfirmation, [mbYes, mbNo], 0, mbNo) = IDNo then exit;

  WIC := TWicImage.Create;                                                 // TWicImage
  try
    WIC.Assign(OutputBitmap);                                              // TWicImageɃrbg}bvf[^[t
    WIC.ImageFormat := WICF;                                               // ۑtH[}bgZbg
    WIC.SaveTofile(Fname);                                                 // t@C̏o
  finally
    WIC.Free;                                                              // TWicImage
  end;
end;

//----------------
// ݒ
//----------------
procedure TForm1.FormCreate(Sender: TObject);
begin
  Timer1.Enabled := False;
  Image1.Width  := ImageHWC div 2;
  Image1.Height := ImageHWC div 2;
  ScrollBox1.Height := ImageHWC;
  ScrollBox1.Width  := ImageHWC;
  Image1.Top := 0;
  Image1.Left := 0;
  InputDBitmap  := TBitmap.Create;
  OutputBitmap  := TBitmap.Create;
  InputDBitmap.PixelFormat := pf24bit;
  OutputBitmap.PixelFormat := pf24bit;
  MaskingBtn.Enabled := False;
  FileSaveBtn.Enabled := False;
  RepaintBtn.Enabled := False;
  sourceBtn.Enabled := False;
  RadioGroup1.Enabled := False;
  TimerF := 0;
  Timer1.Enabled := True;
end;

//----------------
// I
//----------------
procedure TForm1.FormDestroy(Sender: TObject);
begin
  InputDBitmap.Free;
  OutputBitmap.Free;
end;

end.
